import os
import sys
import pygtk
import gtk
import hildon
import hildondesktop
from voo2do import Voo2Do
from toodledo import Toodledo
from rtm import RTM
from xml.dom import minidom
import toolbox
from pyTodoUI import pyTodoUI
import gobject
from MessageBox import *
import logging

ui = None

def check_for_network(aUI=None):
   logging.debug("Checking for network")
   recordfile = os.environ['HOME']+'/.zutun/record.xml'
   if (not os.path.exists(recordfile)):
      return True
   else:
      try:
         if (aUI != None): aUI.record_recorded_entries()
      except:
         logging.debug(sys.exc_info()[0])
         logging.debug(sys.exc_info()[1])
      return True

def hd_plugin_get_objects():

   TRUE = 1
   FALSE = 0

   voo = None

   configdir = os.environ['HOME']+'/.zutun/'
   if (not os.path.exists(configdir)):
      os.system('mkdir '+configdir)

   logging.basicConfig(level=logging.DEBUG,
                    format='%(asctime)s %(levelname)s %(message)s',
                    filename=configdir+'zutun.log',
                    filemode='a')

   # Initialize configuration parameters
   username = None
   password = None
   service = None
   interval = 5
   
   versionString = "zutun version 0.8 (032008)"
   logging.debug( versionString )

### Configuration information

   if os.path.exists(configdir+'conf.xml'):
      gotConfig = True
      fd = open(configdir+'conf.xml')
      xmldoc = minidom.parse(fd).documentElement
      fd.close()

      conf = xmldoc.getElementsByTagName("username")
      username = conf.item(0).firstChild.data
      conf = xmldoc.getElementsByTagName("password")
      password = conf.item(0).firstChild.data
      conf = xmldoc.getElementsByTagName("service")
      service = conf.item(0).firstChild.data
      conf = xmldoc.getElementsByTagName("interval")
      if conf != None:
         interval = int(conf.item(0).firstChild.data)

   else:
      ## open a dialog to ask for config information
      gotConfig = False



# Create the interface

   logging.debug('About to start the interface')
   ui = pyTodoUI(username,password,service)
   timer = gobject.timeout_add(60000*interval, check_for_network, ui)
   logging.debug('Interface created.')
   return [ui]
