import pygtk
import gtk
import hildon
import os
import hildondesktop
from voo2do import Voo2Do
from toodledo import Toodledo
from rtm import RTM
from xml.dom import minidom
from MessageBox import *
import logging
import sys

class pyTodoUI(hildondesktop.HomeItem):
    def __init__(self, username, password, service):
        hildondesktop.HomeItem.__init__(self)

        self.configdir = os.environ['HOME']+'/.zutun/'
        #self.configdir = '/tmp/'
        self.imagedir = '/usr/share/zutun/'

	self.todohandle = None
        self.username = username
        self.password = password
        self.service = service

        self.keyPressed = False

        watchOutput = open(self.configdir + 'ui.log', 'w')
        #sys.stdout = watchOutput
        #sys.stderr = watchOutput

        #logging.basicConfig(level=logging.DEBUG,
        #            format='%(asctime)s %(levelname)s %(message)s',
        #            filename=self.configdir+'zutun.log',
        #            filemode='a')

        if (self.service == "Voo2Do"):
           imageFile = self.imagedir+"voo2do.png"
        elif (self.service == "Toodledo"):
           imageFile = self.imagedir+"toodledo.png"
        elif (self.service == "RTM"):
           imageFile = self.imagedir+"rtm.png"
        else:
           imageFile = self.imagedir+"notconfigured.png"

        #logging.debug.debug("Image file = "+imageFile)

        self.theButton = gtk.Button()
        self.theButton.connect("clicked", self.collectEntry, "TheButton")
        self.theButton.connect("key-press-event", self.keyPress, "TheButton")
        self.theButton.connect("key-release-event", self.keyRelease, "TheButton")
        self.buttonBox = self.picLabelBox(self, imageFile, "")
        self.theButton.add(self.buttonBox)

        self.buttonBox.show()
        self.theButton.show()

        self.add(self.theButton)

    def picLabelBox(self, parent, filename, label_text):
        #logging.debug.debug("Creating a label box with "+filename)
        # Create box for image and label
        box1 = gtk.HBox(False, 0)
        box1.set_border_width(2)

        # Now on to the image stuff
        image = gtk.Image()
        image.set_from_file(filename)

        # Create a label for the button
        label = gtk.Label(label_text)

        # Pack the image and label into the box
        box1.pack_start(image, False, False, 3)
        box1.pack_start(label, False, False, 3)

        image.show()
        label.show()
      
        return box1

    def online(self):
        code = os.system("netstat -rn | grep '0\.0\.0\.0'")
        if (code != 0): 
            ###logging.debug.debug("Not online")
            return False
        else:
            ###logging.debug.debug("Online")
            return True

    def getProjects(self):
        if (self.online()):
            projects = self.todohandle.getProjects()

            projectsdatafile = open(self.configdir+'projects.xml', 'w')
            projectsdatafile.write('<response method="getProjects">\n')
            for proj in projects:
		###logging.debug.debug(proj)
                if len(proj) > 0: 
                    proj = proj.replace('&', '\\&')
                    projectsdatafile.write('<project projName="'+proj+'" />\n')
            projectsdatafile.write('</response>\n')
            projectsdatafile.close()
        else: 
            if os.path.exists(self.configdir+'projects.xml'):
                fd = open(self.configdir+'projects.xml')
                xmldoc = minidom.parse(fd).documentElement
                fd.close()
                projstr = ""
                for proj in xmldoc.getElementsByTagName("project"):
                   projstr += proj.attributes["projName"].value
                   projstr += "|"
                projects = projstr.split('|')
            else:
                mb = MessageBox("There is no project info.\nYou need to be connected\nonce to collect and store it.")
                mb.run()
                projects = None

        return projects

    def getContexts(self):
        if (self.online()):
            ###logging.debug.debug("Getting Toodledo contexts")
            contexts = self.todohandle.getContexts()

            ###logging.debug.debug("Writing contexts file")
            contextsdatafile = open(self.configdir+'contexts.xml', 'w')
            contextsdatafile.write('<response method="getContexts">\n')
            for con in contexts:
		###logging.debug.debug(con)
                if len(con) > 0: 
                    con = con.replace('&', '\\&')
                    contextsdatafile.write('<context conName="'+con+'" />\n')
            contextsdatafile.write('</response>\n')
            contextsdatafile.close()
        else: 
            if os.path.exists(self.configdir+'contexts.xml'):
                fd = open(self.configdir+'contexts.xml')
                xmldoc = minidom.parse(fd).documentElement
                fd.close()
                constr = ""
                for con in xmldoc.getElementsByTagName("context"):
                   constr += con.attributes["conName"].value
                   constr += "|"
                contexts = constr.split('|')
            else:
                mb = MessageBox("There is no project info.\nYou need to be connected\nonce to collect and store it.")
                mb.run()
                contexts = None

        return contexts

    def keyPress(self, widget, key, data=None):
       print("KeyPress activated")
       self.keyPressed = True
       return True

    def keyRelease(self, widget, key, data=None):
       print("KeyRelease activated")
       self.keyPressed = False
       return True

    def configurationDialog(self):
       buttons = 'OK', 1, 'Cancel', 0
       dialog = gtk.Dialog("Enter Configuration", None, 
                       gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                       buttons)
       line1 = gtk.HBox(False, 0)
       label = gtk.Label("Service: ")
       line1.pack_start(label, True, True, 0)
       label.show()
       self.todoService = gtk.combo_box_new_text()
       self.todoService.append_text("Voo2Do")
       self.todoService.append_text("Toodledo")
       #self.todoService.append_text("RTM")
       line1.pack_start(self.todoService, True, True, 0)
       self.todoService.show()
       line1.show()
       dialog.vbox.pack_start(line1, True, True, 0)
       line2 = gtk.HBox(False, 0)
       label = gtk.Label("Username: ")
       line2.pack_start(label, True, True, 0)
       label.show()
       self.todoUsername = gtk.Entry(256)
       line2.pack_start(self.todoUsername, True, True, 0)
       self.todoUsername.show()
       line2.show()
       dialog.vbox.pack_start(line2, True, True, 0)
       line3 = gtk.HBox(False, 0)
       label = gtk.Label("Password: ")
       line3.pack_start(label, True, True, 0)
       label.show()
       self.todoPassword = gtk.Entry(256)
       self.todoPassword.set_visibility(False)
       line3.pack_start(self.todoPassword, True, True, 0)
       self.todoPassword.show()
       line3.show()
       dialog.vbox.pack_start(line3, True, True, 0)
       line4 = gtk.HBox(False, 0)
       label = gtk.Label("Net Check Interval: ")
       line4.pack_start(label, True, True, 0)
       label.show()
       self.checkInterval = gtk.Entry(256)
       self.checkInterval.set_text('5')
       line4.pack_start(self.checkInterval, True, True, 0)
       self.checkInterval.show()
       (w,h) = self.checkInterval.get_size_request()
       self.checkInterval.set_size_request(60,h)
       line4.show()
       dialog.vbox.pack_start(line4, True, True, 0)

       return dialog

    def collectionDialog(self, todoCategories, todoContexts=None):
        buttons = 'Record', 1, 'Cancel', 0
        dialog = gtk.Dialog(self.service+": Todo Item", None, 
                       gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                       buttons)

        widgetTable = gtk.Table(4, 3)
        ##window.add(widgetTable)
        
        label = gtk.Label("Todo Item:")
        widgetTable.attach(label, 0, 1, 0, 1)
        label.show()
        
        self.todoItem = gtk.Entry(256)
        widgetTable.attach(self.todoItem, 0, 2, 1, 2)
        self.todoItem.show()

        label = gtk.Label("Category:")
        widgetTable.attach(label, 0, 1, 2, 3)
        label.show()

        self.categories = gtk.combo_box_new_text()
        for str in todoCategories:
            self.categories.append_text(str)
        widgetTable.attach(self.categories, 0, 1, 3, 4, 0, 0)
        self.categories.show()
        
        label = gtk.Label("Pri:")
        widgetTable.attach(label, 1, 2, 2, 3)
        label.show()
        self.priority = gtk.Entry(3);
        (w,h) = self.priority.get_size_request()
        self.priority.set_size_request(60,h)
        widgetTable.attach(self.priority, 1, 2, 3, 4, 0, 0)
        self.priority.show()

        label = gtk.Label("Due:")
        widgetTable.attach(label, 2, 3, 2, 3)
        label.show()
        self.duedate = gtk.Entry(15);
        widgetTable.attach(self.duedate, 2, 3, 3, 4)
        self.duedate.show()
        
        if todoContexts != None:
            label = gtk.Label("Context:")
            widgetTable.attach(label, 0, 1, 4, 5)
            label.show()

            self.contexts = gtk.combo_box_new_text()
            for str in todoContexts:
                self.contexts.append_text(str)
            widgetTable.attach(self.contexts, 0, 1, 5, 6, 0, 0)
            self.contexts.show()

        widgetTable.set_row_spacing(0,10)
        widgetTable.show()

        dialog.vbox.pack_start(widgetTable, True, True, 0)

        return dialog

    def collectEntry(self, widget, data=None):
        #logging.debug.debug("Entering collectEntry, service = "+self.service)
        if (self.todohandle == None):
           #logging.debug.debug("...todohandle == None")
           if self.service == "Voo2Do":
              self.todohandle = Voo2Do(self.username, self.password)
           elif self.service == "Toodledo":
              self.todohandle = Toodledo(self.username, self.password)
           elif self.service == "RTM":
              self.todohandle = RTM(self.username, self.password)
           else:
              self.todohandle = None
        else:
           pass
     
        if (self.todohandle == None or self.keyPressed):
           self.keyPressed = False
           dialog = self.configurationDialog()
           response = -1
           while response<0:
              response = dialog.run()
              print "Response = "+str(response)
              if response == 0:
                 dialog.destroy()
              else: 
                 model = self.todoService.get_model()
                 index = self.todoService.get_active()
                 if (index == -1):
                    mb = MessageBox("Please select a service")
                    mb.run()
                    response = -1
                 else:
                    self.interval = self.checkInterval.get_text()
                    if (self.interval == ""):
                       mb = MessageBox("Please specify an interval")
                       mb.run()
                       response = -1
                    else:
                       self.service = model[index][0]
                       self.username = self.todoUsername.get_text()
                       self.password = self.todoPassword.get_text()
                       configfile = open(self.configdir+'conf.xml', 'w')
                       configfile.write('<config>\n')
                       configfile.write('   <username>'+self.username+'</username>\n')
                       configfile.write('   <password>'+self.password+'</password>\n')
                       configfile.write('   <service>'+self.service+'</service>\n')
                       configfile.write('   <interval>'+self.interval+'</interval>\n')
                       configfile.write('</config>\n')
                       configfile.close()

                       if (self.service == "Voo2Do"):
                          imageFile = self.imagedir+"voo2do.png"
                       elif (self.service == "Toodledo"):
                          imageFile = self.imagedir+"toodledo.png"
                       elif (self.service == "RTM"):
                          imageFile = self.imagedir+"rtm.png"
                       else:
                          imageFile = self.imagedir+"notconfigured.png"
       
                       self.buttonBox.destroy()
                       self.buttonBox = self.picLabelBox(self, imageFile, "")
                       self.theButton.add(self.buttonBox)
                       self.buttonBox.show()

                       dialog.destroy()
           
        else:
           ##logging.debug.debug("Calling for a collection dialog")
           projects = self.getProjects()
           contexts = None
           if self.service == "Toodledo":
              contexts = self.getContexts()
              ##logging.debug.debug(contexts)
           if projects != None:
              dialog = self.collectionDialog(projects,contexts)
              response = -1
              while (response < 0):
                 response = dialog.run()
                 if (response == 1):
                    response = self.recordEntry() 
                 if (response >= 0):
                    dialog.destroy()     

    def record_recorded_entries(self):
       ###logging.debug.debug("Recording offline entries")
       if (self.online()):
          if (self.todohandle == None):
             if self.service == "Voo2Do":
                self.todohandle = Voo2Do(self.username, self.password)
             elif self.service == "Toodledo":
                self.todohandle = Toodledo(self.username, self.password)
             elif self.service == "RTM":
                self.todohandle = RTM(self.username, self.password)
             else:
                self.todohandle = None
    
          if (self.todohandle != None):
             conf = os.environ['HOME']+'/.zutun/'
             fd = open(conf+'record.xml')
             xmldoc = minidom.parse(fd).documentElement
             fd.close()
             for todoitem in xmldoc.getElementsByTagName("todoitem"):
                item = todoitem.attributes["item"].value
                category = todoitem.attributes["category"].value
                priority = todoitem.attributes["priority"].value
                duedate = todoitem.attributes["duedate"].value
                context = todoitem.attributes["context"].value
                self.todohandle.saveTask(item, category, priority, duedate, context)
             os.remove(self.configdir+'record.xml')

    def write_entry(self, item, category, priority, duedate, context=""):
        ###logging.debug.debug('Entering write_entry')
        if os.path.exists(self.configdir+'record.xml'):
           fd = open(self.configdir+'record.xml')
           xmldoc = minidom.parse(fd).documentElement
           fd.close()
        else:
           xmldoc = None

        ###logging.debug.debug('About to write to record.xml')
        fd = open(self.configdir+'record.xml', 'w')
        fd.write('<recordeditems>\n')
        if (xmldoc != None):
            ###logging.debug.debug("Writing old recorded entries")
            recstr = '<todoitem '
            for rec in xmldoc.getElementsByTagName("todoitem"):
                recstr += 'item="'+rec.attributes["item"].value+'" '
                recstr += 'category="'+rec.attributes["category"].value+'" '
                recstr += 'priority="'+rec.attributes["priority"].value+'" '
                recstr += 'duedate="'+rec.attributes["duedate"].value+'" '
                con = rec.attributes["context"].value
                if con != None:
                   recstr += ' context="'+con+'" '
            recstr += '></todoitem>\n'
            ###logging.debug.debug("Writing "+recstr)
            fd.write(recstr+'\n')

        fd.write('<todoitem item="'
                     +item+'" category="'+category+'" priority="'
                     +priority+'" duedate="'+duedate+'"')
        if context != None:
           fd.write(' context="'+context+'"')
        fd.write(' ></todoitem>\n')
        fd.write('</recordeditems>\n');
        fd.close()

    def recordEntry(self):
        item = self.todoItem.get_text()
        if item == "": 
            mb = MessageBox("The item may not be left blank")   
            mb.run() 
            return -1
            
        model = self.categories.get_model()
        index = self.categories.get_active()
        if index == -1:
            mb = MessageBox("You must specify a category")    
            mb.run()
            return -1
        else:   
            priority = self.priority.get_text()
            duedate = self.duedate.get_text()
            category = model[index][0]
            if self.service == "Toodledo":
                model = self.contexts.get_model()
                index = self.contexts.get_active()
                context = model[index][0]
            else:
                context = ""
            if self.todohandle == None:
               if self.service == "Voo2Do":
                  self.todohandle = Voo2Do(username, password)
               elif self.service == "Toodledo":
                  self.todohandle = Toodledo(username, password)
               elif self.service == "RTM":
                  self.todohandle = RTM(self.username, self.password)
               else:
                  self.todohandle = None

            if not self.online():
               self.write_entry(item, category, priority, duedate, context)
            else:
               if self.service == "Toodledo":
                   self.todohandle.saveTask(item, category, priority, duedate, context)
               else:
                   self.todohandle.saveTask(item, category, priority, duedate)

               # check for other saved tasks
               if os.path.exists(self.configdir+'record.xml'):
                  self.record_recorded_entries()
            
            return 1

