__version__ = "0.4"
__author__ = "ykabhinav"
__credits__ = "Contributions from ruibalp"
__copyright__ = "(C) 2007 ykabhinav."

import socket
import sys
from xml.sax import saxutils
from xml.sax import make_parser
from xml.sax.handler import feature_namespaces
import toolbox
import hashlib
import urllib, urllib2
import time
import webbrowser

class RTM:
    "Class to interface with rememberthemilk.com"
    hash = None
    apikey = None
    secret = None
    token = None
    sock = None

    def __init__(self, api, secret, token=''):
        self.apikey = api
        self.secret = secret
        self.projlist = None
        self.conlist = None
        self.token = ''
        self.time = 0
        self.configdir = '/home/user/.zutun/'

        print("Initializing the RTM object\n")

        try:
           frobstr = self.rtm_auth_getFrob()
           print("Got the frobstring: "+frobstr+"\n")
        except:
           print(sys.exc_info()[0])
           print(sys.exc_info()[1])

        frobdom = toolbox.loadXML(frobstr)
        frob = frobdom.getElementsByTagName('frob')[0].childNodes[0].data

        print("Got the frob: "+frob+"\n")

        params = {}
        params['frob'] = frob
        params['api_key'] = self.apikey
        params['perms'] = 'write'
        params['api_sig'] = self.sign_request(params)

        url = 'http://www.rememberthemilk.com/services/auth/?' + urllib.urlencode(params)
        print("Authorizing: "+url)
        webbrowser.open_new(url)
        time.sleep(45)
        
        auth_xml = self.rtm_auth_getToken({'frob': params['frob']})
        dom = xml.dom.minidom.parseString(auth_xml)

        self.token = dom.getElementsByTagName('token')[0].childNodes[0].data

    def init(self, api, secret, token=''):
        self.apikey = api
        self.secret = secret
        self.projlist = None
        self.conlist = None
        self.token = ''
        self.time = 0
        
        dom = xml.dom.minidom.parseString(self.rtm_auth_getFrob())
        frob = dom.getElementsByTagName('frob')[0].childNodes[0].data
        
        params = {}
        params['frob'] = frob
        params['api_key'] = self.apikey
        params['perms'] = 'write'
        params['api_sig'] = self.sign_request(params)

        url = 'http://www.rememberthemilk.com/services/auth/?' + urllib.urlencode(params)
        
        auth_xml = self.rtm_auth_getToken({'frob': params['frob']})
        dom = xml.dom.minidom.parseString(auth_xml)

        self.token = dom.getElementsByTagName('token')[0].childNodes[0].data

    def sign_request(self, params):
        '''params - all the parameters send to server.

           Signs paramaters according to:
             http://www.rememberthemilk.com/services/api/
                authentication.rtm'''
        keys = params.keys()
        keys.sort()

        sig_str = self.secret
        for key in keys:
            sig_str += key + params[key]

        return hashlib.md5(sig_str).hexdigest()

    def __make_request(self, method, params):
        '''method - the api method we are calling.
           params - the params that we are sending for the method.

           Makes a request for the api method from rmilk. Also puts a
           one second delay between calls.'''
        params['api_key'] = self.apikey
        params['method'] = method

        if self.token is not '':
            params['auth_token'] = self.token

        params['api_sig'] = self.sign_request(params)

        url = 'http://www.rememberthemilk.com/services/rest/?' + urllib.urlencode(params)

        atime = time.time() - self.time;
        if atime < 1:
            atime = 1 - atime
            time.sleep(atime)

        req = urllib2.urlopen(url)
        result = req.read();

        self.time += atime;

        return result

    def __getattr__(self, name):
        '''The magic.'''
        def __func(params={}):
            return self.__make_request(name.replace('_', '.'), params)

        return __func

    def getHash(self):
        return self.token
        
    def getProjects(self):
        if (self.hash == "None"):
           self.init(self.userID, self.password) 
        specHash = self.token
        specID = self.apikey
        
        xmlstr = rtm_lists_getLists()
        projResponse = toolbox.loadXML(xmlstr)
        
        projstr = ""
        self.fidlist = []
        for proj in projResponse.getElementsByTagName("list"):
            fid = proj.attributes["id"].value
            self.fidlist.append(fid)
            projstr += proj.attributes["name"]
            projstr += "|"
        self.projlist = projstr.split('|')
        print self.fidlist
        
        return self.projlist
        
    def getContexts(self, possibleID=None, possibleHash=None):
        return None
        
    def saveTask(self, taskDesc, projName, priority, duedate, conName):
        specHash = self.hash
        specID = self.userID

        index=0
        cindex=0
        if (self.projlist == None): self.getProjects()
        for proj in self.projlist:
           if proj == projName:
              break
           index += 1

        taskDesc = taskDesc.replace(" ","%20")
        xmlstr = rtm_tasks_add({'list_id': fidlist[findex], 
                                'name': taskDesc, 
                                'timeline': str(tramp.timeline)})

        projResponse = toolbox.loadXML(xmlstr)
