import socket
import sys
from xml.sax import saxutils
from xml.sax import make_parser
from xml.sax.handler import feature_namespaces
import toolbox

class Voo2Do:
    "Class to interface with voo2do.com"
    HOST = 'www.voo2do.com'
    PORT = 80
    hash = None
    userID = None
    password = None
    sock = None

    def __init__(self, username, password):
        self.userID = username
        self.password = password
        self.projlist = None
        
        url = "http://www.voo2do.com/api/getLoginHash?email="+username+"&password="+password
        errorResponse = '<response><login loginHash="None" userId="None"></login></response>'
        self.loginResponse = toolbox.loadXML(url, errorResponse)
        for tag in self.loginResponse.getElementsByTagName("login"):
            self.hash = tag.attributes["loginHash"].value
            self.userID = tag.attributes["userId"].value
        
    def init(self, username, password):
        self.userID = username
        self.password = password

        url = "http://www.voo2do.com/api/getLoginHash?email="+username+"&password="+password
        errorResponse = '<response><login loginHash="None" userId="None"></login></response>'
        self.loginResponse = toolbox.loadXML(url, errorResponse)
        for tag in self.loginResponse.getElementsByTagName("login"):
            self.hash = tag.attributes["loginHash"].value
            self.userID = tag.attributes["userId"].value
        
    def getHash(self):
        return self.hash
        
    def getProjects(self, possibleID=None, possibleHash=None):
        if (self.hash == "None"):
           #logging.debug("Reinitializing the Voo2Do object")
           self.init(self.userID, self.password)
        specHash = self.hash
        if possibleHash != None: specHash = possibleHash
        specID = self.userID
        if possibleID != None: specID = possibleID
        
        url = 'http://www.voo2do.com/api/getProjects?userId='+specID+'&loginHash='+specHash
        projResponse = toolbox.loadXML(url)
        projstr = ""
        for proj in projResponse.getElementsByTagName("project"):
            projstr += proj.attributes["projName"].value
            projstr += "|"
        projlist = projstr.split('|')
        
        return projlist
        
    def saveTask(self, taskDesc, projName, priority, duedate=""):
        specHash = self.hash
        specID = self.userID
        taskDesc = taskDesc.replace(" ","%20")
        url = 'http://www.voo2do.com/api/saveTask?userId='+self.userID+'&loginHash='+self.hash+'&projName='+projName+'&taskdesc='+taskDesc+"&priority="+priority
        if duedate != "":
           url += "&deadline="+duedate
        projResponse = toolbox.loadXML(url)
